<template>
  <div ref="mapContainer" class="w-full h-full" :class="viewChange" >
    <div id="map" class="w-full h-full"></div>
    <div id="popup" ref="popup" class="popup"></div>
    <MapToggleControl class="absolute bottom-20 left-6" v-model="showDioceseBorders" label="Bistumsgrenzen"/>
    <MapToggleControl class="absolute bottom-6 left-6" v-model="showClusters" label="Marker als Cluster"/>
    <div v-if="loading" id="map" class="absolute top-0 left-0 w-full h-full bg-gray-200 flex items-center justify-center">
      <i class="pi pi-spin pi-spinner-dotted text-primary-500 !text-3xl" />
    </div>
  </div>
</template>

<script>
import 'ol/ol.css';
import '@/ol-layerswitcher/ol-layerswitcher.css';
import 'ol-ext/dist/ol-ext.css';
import SelectCluster from 'ol-ext/interaction/SelectCluster';
import { Map, Overlay, View } from 'ol';
import TileLayer from 'ol/layer/Tile';
import OSM, { ATTRIBUTION } from 'ol/source/OSM';
import LayerGroup from 'ol/layer/Group';
import VectorSource from 'ol/source/Vector';
import VectorImageLayer from 'ol/layer/VectorImage';
import { Cluster } from 'ol/source';
import Icon from 'ol/style/Icon';
import { fromLonLat } from 'ol/proj';
import { defaults } from 'ol/control';
import GeoJSON from 'ol/format/GeoJSON';
import { Fill, Stroke, Style, Text } from 'ol/style';
import * as proj from 'ol/proj';
import * as olColor from 'ol/color';
import { imagePaths } from '@/mixins/imagePaths';
import MapToggleControl from "@/components/MapToggleControl.vue";

export default {
  name: 'MonasteriesMap',
  components: {MapToggleControl},
  data () {
    return {
      map: null,
      view: null,
      markersSource: null,
      highlightSource: null,
      currentGSN: -1,
      popupOverlay: null,
      loadingMap: true,
      showDioceseBorders: true,
      showClusters: false,
      resizeObserver: null,
    };
  },
  computed: {
    loading () {
      return this.$store.state.loadingLocations || this.$store.state.loadingDetail || this.loadingMap;
    },
    locations () {
      return this.$store.state.locations;
    },
    monasteryDetail () {
      return this.$store.state.monasteryDetail;
    },
    orderSymbolsMap () {
      return this.$store.state.orderSymbolsMap;
    },
    popup () {
      return this.$refs['popup'];
    },
    isMobile () {
      return this.$store.state.isMobile;
    },
    viewChange () {
      return this.$store.state.view;
    },
  },
  mounted () {
    this.resizeObserver = new ResizeObserver(() => this.map?.updateSize());
    this.resizeObserver.observe(this.$refs.mapContainer);
    this.view = new View({
      center: fromLonLat([12.956, 51.378]),
      zoom: 6,
    });

    this.map = new Map({
      target: 'map',
      layers: [
        new LayerGroup({
          title: 'Basemap',
          layers: [
            new TileLayer({
              title: 'OSM',
              type: 'base',
              source: new OSM({
                attributions: [
                  ATTRIBUTION],
              }),
            }),
          ],
        }),
        new LayerGroup({
          title: 'Klosterstandorte',
          exclusive: true,
          layers: [],
        }),
      ],
      view: this.view,
      controls: defaults(),
    });

    this.popupOverlay = new Overlay({
      element: this.popup,
      offset: [-210, 24],
    });
    this.map.addOverlay(this.popupOverlay);
    // this.map.addControl(new LayerSwitcher({ reverse: true, startActive: false, activationMode: 'click' }));
    this.map.on('click', (event) => {
      if (this.highlightSource) this.highlightSource.clear();
    });
    let lastHoverDiocese;
    this.map.on('pointermove', (event) => {
      if (event.dragging) {
        return;
      }

      let topMarker;
      let diocese;
      this.map.forEachFeatureAtPixel(event.pixel, function (feature, layer) {
        if (layer && layer.get('title') === 'Bistumsgrenzen') {
          diocese = feature;
        } else {
          topMarker = feature;
        }
      });

      if (!this.isMobile && topMarker && topMarker.get('features')) {
        this.popup.hidden = false;
        const data = topMarker.get('features')[0];
        this.popup.innerHTML = this.createTooltip(data);
        this.popupOverlay.setPosition(topMarker.getGeometry().getCoordinates());
      } else {
        this.popup.hidden = true;
      }

      if (lastHoverDiocese) {
        lastHoverDiocese.set('hoverDiocese', false);
      }

      if (diocese) {
        diocese.set('hoverDiocese', true);
        lastHoverDiocese = diocese;
      }
    });

    this.setDioceseBorders();
    this.loadingMap = false;
  },
  unmounted() {
    if (this.resizeObserver) {
      this.resizeObserver.disconnect();
    }
  },
  methods: {
    setViewDetail (detail) {
      this.loadingMap = true;
      if (this.map && detail.locations) {
        this.map.updateSize();
        setTimeout(() => this.loadingMap = false, 250);
        if (this.currentGSN !== detail.gsnId) {
          this.currentGSN = detail.gsnId;
          this.selectMarkers(detail.gsnId);
        }
      }
    },
    selectMarkers (gsnId) {
      if (this.markersSource && this.highlightSource) {
        const markers = this.markersSource.getFeatures();
        const locationsById = this.getLocationsById(gsnId, markers);
        this.highlightSource.clear();
        this.highlightSource.addFeatures(locationsById);
        let zoomSource = this.highlightSource;
        if (locationsById.length === 0) zoomSource = this.markersSource;
        if (locationsById.length === 1) {
          this.zoomToSingleLocation(locationsById[0]);
        } else if (locationsById.length > 1) {
          const sameLocation = this.checkForSameLocations(locationsById);
          if (sameLocation) this.zoomToSingleLocation(locationsById[0]);
          else this.setMapView(zoomSource);
        }
      }
    },
    getLocationsById (gsnIdKey, locations) {
      return locations.filter(function (entry) {
        return parseInt(gsnIdKey) === parseInt(entry.get('gsnId'));
      });
    },
    checkForSameLocations (locations) {
      const firstLocation = locations[0].getGeometry().getCoordinates().toString();
      for (let i = 1; i < locations.length; i++) {
        if (locations[i].getGeometry().getCoordinates().toString() !== firstLocation) return false;
      }
      return true;
    },
    handleSelection (event) {
      const selected = event.selected;
      if (selected.length < 1) return;
      const markers = [];
      if (selected[0].get('features')) {
        selected[0].get('features').forEach(obj => {
          markers.push(obj);
        });
      } else if (selected[0].get('Name')) { // diocese border
        this.map.getView().fit(selected[0].getGeometry().getExtent());
      }

      if (markers.length === 1) { // no cluster
        const gsnId = markers[0].get('gsnId');
        if (!gsnId) return;
        const sameId = parseInt(gsnId) === parseInt(this.currentGSN);
        if (!sameId) {
          this.$router.replace({ path: '/gsn/' + gsnId });
        } else {
          this.currentGSN = gsnId;
        }
        this.selectMarkers(gsnId);
      }
    },
    getHighlightStyle (feature) {
      const order = feature.get('orders')[0];
      const image = this.getImageFromOrder(order);
      return [
        new Style({
          image: new Icon({
            anchor: [0.5, 32],
            anchorXUnits: 'fraction',
            anchorYUnits: 'pixels',
            scale: [0.7, 0.7],
            src: image,
            color: '#eb5934',
          }),
        }),
      ];
    },
    getClusterItemStyle (feature, resolution) {
      const styles = [];
      const cluster = feature.get('features');
      if (typeof (cluster) === 'undefined') return;
      cluster.forEach(item => {
        const order = item.get('orders')[0];
        const image = this.getImageFromOrder(order);
        const style = new Style({
          image: new Icon({
            anchor: [0.5, 32],
            anchorXUnits: 'fraction',
            anchorYUnits: 'pixels',
            scale: [0.5, 0.5],
            src: image,
          }),
        });
        styles.push(style);
      });

      return styles;
    },
    getClusterTextStyle (text) {
      return new Text({
        text: text.toString(),
        offsetY: -3,
        font: 'bold 12px sans-serif',
        fill: new Fill({
          color: '#000',
        }),
        stroke: new Stroke({
          color: '#fff',
          width: 3,
        }),
      });
    },
    getMonasterySymbol (url) {
      return new Icon({
        anchor: [0.5, 32],
        anchorXUnits: 'fraction',
        anchorYUnits: 'pixels',
        scale: [0.5, 0.5],
        src: url,
      });
    },
    getImageFromOrder (order) {
      const orderName = order ? order.name : '';
      const imageName = this.orderSymbolsMap[orderName] ?? 'default_monastery';
      return imagePaths.getMarker(imageName);
    },
    getClusterStyle (f, resolution) {
      if (!f || !f.get('features')) return;
      const size = f.get('features').length;
      if (size === 1) {
        const feature = f.get('features')[0];
        const order = feature.get('orders')[0];
        const image = this.getImageFromOrder(order);
        const selectColor = '#eb5934';
        return [
          new Style({
            image: new Icon({
              anchor: [0.5, 32],
              anchorXUnits: 'fraction',
              anchorYUnits: 'pixels',
              scale: [0.5, 0.5],
              src: image,
              color: selectColor,
            }),
          }),
        ];
      }
      return [
        new Style({
          image: this.getMonasterySymbol(imagePaths.getMarkerTemplate()),
          text: this.getClusterTextStyle(size),
        }),
      ];
    },
    setMonasteryLocations (locations) {
      this.loadingMap = true;
      const geojson = { type: 'FeatureCollection', features: locations };
      const features = new GeoJSON().readFeatures(geojson, { featureProjection: proj.get('EPSG:3857') });
      const styleCache = {};
      const clusterStyleCache = {};
      const getMonasteryStyle = (f, resolution, isCluster) => {
        const size = f.get('features').length;
        const feature = f.get('features')[0];
        const order = feature.get('orders')[0];
        const orderName = order ? order.name : '';
        const imageUrl = this.getImageFromOrder(order);
        let style = styleCache[orderName];
        if (!style) {
          style = new Style({
            image: this.getMonasterySymbol(imageUrl),
          });
          styleCache[orderName] = style;
        }

        if (size > 1 && ((!isCluster && resolution < 200) || isCluster)) {
          let clusterStyle = clusterStyleCache[size];
          if (!clusterStyle) {
            clusterStyle = new Style({
              image: this.getMonasterySymbol(imagePaths.getMarkerTemplate()),
              text: this.getClusterTextStyle(size),
            });
            clusterStyleCache[size] = clusterStyle;
          }
          return [clusterStyle];
        }
        return [style];
      };

      if (!this.selectCluster) {
        this.selectCluster = new SelectCluster({
          pointRadius: 25,
          animate: true,
          featureStyle: this.getClusterItemStyle,
          style: this.getClusterStyle,
        });
        this.map.addInteraction(this.selectCluster);
        this.selectCluster.on('select', this.handleSelection);
      }

      if (this.markersSource) {
        this.markersSource.clear();
      } else {
        this.markersSource = new VectorSource();
        this.clusterSource = new Cluster({
          distance: 0.01,
          source: this.markersSource,
        });

        const allMonasteries = new VectorImageLayer({
          title: 'Komplette Übersicht',
          type: 'base',
          source: this.clusterSource,
          style: (f, r) => getMonasteryStyle(f, r, false),
        });

        const clusteredMonasteries = new VectorImageLayer({
          title: 'Geclusterte Version',
          type: 'base',
          visible: false,
          source: new Cluster({
            distance: 50,
            source: this.markersSource,
          }),
          style: (f, r) => getMonasteryStyle(f, r, true),
        });

        this.map.getLayers().forEach((item, i) => {
          const title = item.get('title');
          if (title === 'Klosterstandorte') {
            if (item.get('layers')) {
              const groupLayers = item.get('layers');
              groupLayers.push(clusteredMonasteries);
              groupLayers.push(allMonasteries);
            }
          }
        });
      }
      if (this.highlightSource) {
        this.highlightSource.clear();
      } else {
        this.highlightSource = new VectorSource();
        const highlightLayer = new VectorImageLayer({
          source: this.highlightSource,
          style: this.getHighlightStyle,
        });
        this.map.addLayer(highlightLayer);
      }
      this.markersSource.addFeatures(features);
      if (this.currentGSN !== -1) { // ID was selected before loading markers
        this.selectMarkers(this.currentGSN);
      } else this.setMapView(this.markersSource);
      setTimeout(() => this.loadingMap = false, 500);
    },
    setMapView (source) {
      if (!source) this.setDefaultView();
      const features = source.getFeatures();
      if (features.length > 1 && features.length < 3800) {
        const sameLocation = this.checkForSameLocations(features);
        if (sameLocation) this.centerAndZoom(features[0]);
        else this.view.fit(source.getExtent(), { padding: [100, 100, 100, 100] });
      } else if (features.length === 1) {
        this.centerAndZoom(features[0]);
      } else this.setDefaultView();
    },
    setDefaultView () {
      this.view.setCenter(fromLonLat([12.956, 51.378]));
      this.view.setZoom(6);
    },
    centerAndZoom (location) {
      this.view.setCenter(location.getGeometry().getCoordinates());
      if (this.map.getView().getZoom() < 14) this.view.setZoom(14);
    },
    zoomToSingleLocation (location) {
      if (!this.isMobile) {
        this.centerAndZoom(location);
      } else {
        const height = window.screen.height;
        const offset = 0.7 * height / 2;
        const centerPixels = this.map.getPixelFromCoordinate(location.getGeometry().getCoordinates());
        const newCenterPixels = [centerPixels[0], centerPixels[1] + offset];
        this.view.setCenter(this.map.getCoordinateFromPixel(newCenterPixels));
      }
    },
    setDioceseBorders () {
      this.$store.dispatch('getDioceseBorders')
        .then(geojson => {
          const features = new GeoJSON().readFeatures(geojson, { featureProjection: proj.get('EPSG:3857') });
          const vectorSource = new VectorSource({
            features: features,
          });
          const vectorLayer = new VectorImageLayer({
            title: 'Bistumsgrenzen',
            source: vectorSource,
            style: this.getDioceseStyle,
          });
          this.map.getLayers().insertAt(1, vectorLayer);
        });
    },
    getDioceseStyle (feature) {
      const name = feature.get('Name');
      const color = feature.get('Color') || '#acacc2';
      const fillColor = [...olColor.asArray(color)];
      let strokeWidth = 2;
      if (feature.get('hoverDiocese')) strokeWidth = 4;
      fillColor[3] = 0.3;
      return new Style({
        stroke: new Stroke({
          color: color,
          width: strokeWidth,
        }),
        fill: new Fill({
          color: fillColor,
        }),
        text: new Text({
          text: name,
          scale: 2,
          textAlign: 'center',
          fill: new Fill({
            color: '#80878c',
          }),
          stroke: new Stroke({
            color: 'rgba(255, 255, 255, 0.4)',
            width: 2,
          }),
        }),
      });
    },
    createTooltip (data) {
      let ordersHtml = '';

      if (data) {
        if (data.get('orders')) {
          data.get('orders').forEach(({ name, from, to }) => {
            const iconPath = imagePaths.getIcon(this.orderSymbolsMap[name]);
            ordersHtml +=
              '<div class="flex flex-wrap items-center">' +
              `<div class="order-from-to flex-1 basis-1/2 pr-2 whitespace-normal">${from} - ${to}</div>` +
              '<div class="order-name flex-shrink flex items-center basis-1/2">' +
              `<img class="order-icon inline w-[18px] h-[18px]" src="${iconPath}" alt=""><span>${name}</span>` +
              '</div>' +
              '</div>';
          });
        }

        return '<div class="marker-info p-4">' +
          '<h4 class="name whitespace-normal break-words">' + (data.get('monasteryName') ?? 'Kein Name gefunden') + '</h4>' +
          '<p>Standort: ' + data.get('locationName') + '</p>' +
          '<p class="gsn-id mb-2 italic">GSN ID: ' + data.get('gsnId') + '</p>' +
          '<p class="font-bold">Zeiträume:</p>' +
          ordersHtml +
          '</div>';
      }
      return '';
    },
  },
  watch: {
    locations: {
      handler: function (locations) {
        this.setMonasteryLocations(locations);
      },
    },
    monasteryDetail: {
      handler: function (detail) {
        this.setViewDetail(detail);
      },
    },
    viewChange: {
      handler: function (view) {
        this.map.updateSize();
        if (this.highlightSource && view === 'map') {
          this.highlightSource.clear();
          this.currentGSN = -1;
          if (!this.loading) this.setMapView(this.markersSource);
        }
      },
    },
    showDioceseBorders: {
      handler: function(value) {
        this.map.getLayers().getArray()[1].setVisible(value)
      }
    },
    showClusters: {
      handler: function(value) {
        const markersGrouplayer = this.map.getLayers().getArray()[2];
        const clusterLayer = markersGrouplayer.getLayers().getArray()[0];
        const singleMarkersLayer = markersGrouplayer.getLayers().getArray()[1];
        if (value) {
          clusterLayer.setVisible(true)
          singleMarkersLayer.setVisible(false)
        } else {
          clusterLayer.setVisible(false)
          singleMarkersLayer.setVisible(true)
        }
      }
    }
  },
};
</script>

<style scoped>
:deep(.ol-control) {
  @apply bg-none p-0 m-0;

  button {
    @apply bg-white text-gray-600 border border-solid border-gray-300 m-0;
    width: 28px;
    height: 28px;

    &:hover, &:focus, &:active {
      @apply bg-primary-500 text-white;
    }

    &:first-child {
      @apply border-b-0;
    }
  }
}

:deep(.ol-zoom) {
  right: 20px;
  bottom: 40px;
  left: auto;
  top: auto;
  @apply shadow-lg;
}

:deep(.ol-zoom button) {
  @apply bg-white text-gray-600;
}

:deep(.ol-attribution) {
  right: 20px !important;
  bottom: 10px !important;
}

.detail {
  :deep(.el-loading-spinner) {
    top: 16%;
    @screen lg {
      top: 50%;
    }
  }
}

:deep(.marker-info) {
  @apply relative bg-white rounded shadow;
  width: 420px;

  &:before {
    content: '';
    @apply absolute bg-white;
    width: 12px;
    height: 12px;
    transform: translateX(-50%) translateY(-50%) rotateZ(-45deg);
    left: 50%;
    top: 0;
  }

  .order-from-to {
    @apply flex-1 pr-2 whitespace-normal;
    flex-basis: 50%;
  }

  .order-name {
    @apply flex-shrink flex items-center;
    flex-basis: 50%;
  }
}
</style>
